Subject: bug#17739: 24.3; Dotted circle does not combine with Thai vowel markers

From: Stefan Kangas <[email-masked]>
Date: Sat, 21 Sep 2019 11:36:54 +0200

Eli Zaretskii <[email-masked]> writes:

> > > I've just committed a function to handle dotted-circle
> > > properly to the trunk.
> >
> > Since there have been no further updates in 5 years, I'm going to
> > assume that the fix worked as expected and close this bug.  If that is
> > incorrect, please report back and we can reopen the bug report.
>
> The original recipe still doesn't display correctly on the current
> master, so I think something is still missing.  Not sure what exactly
> is missing.

OK, you're right.  Reopening.

However, it works properly for me using my init file AFAICT.  I'm
using the following recipe:

1. C-x 8 RET
2. DOTTED CIRCLE RET
3. C-x 8 RET
4. THAI CHARACTER SARA UE RET

1. Using my init file, the characters compose and M-x describe-char gives:

             position: 300 of 3559 (8%), column: 9
            character: ◌ (displayed as ◌) (codepoint 9676, #o22714, #x25cc)
              charset: unicode (Unicode (ISO10646))
code point in charset: 0x25CC
               script: symbol
               syntax: w     which means: word
             category: .:Base
             to input: type "C-x 8 RET 25cc" or "C-x 8 RET DOTTED CIRCLE"
          buffer code: #xE2 #x97 #x8C
            file code: #xE2 #x97 #x8C (encoded by coding system utf-8-unix)
              display: composed to form "◌ึ" (see below)

Composed with the following character(s) "ึ" using this font:
  x:-mutt-clearlyu-medium-r-normal--17-120-100-100-p-123-iso10646-1
by these glyphs:
  [0 1 9676 9676 14 2 13 12 -1 nil]
  [0 1 3638 3638 0 -7 0 14 -9 [0 -3 0]]

Character code properties: customize what to show
  name: DOTTED CIRCLE
  general-category: So (Symbol, Other)
  decomposition: (9676) ('◌')

I've attached a screenshot of the above.

2. When I run under emacs -Q, I see two characters next to each other
and M-x describe-char says:

a)

             position: 146 of 147 (99%), column: 0
            character: ◌ (displayed as ◌) (codepoint 9676, #o22714, #x25cc)
              charset: unicode (Unicode (ISO10646))
code point in charset: 0x25CC
               script: symbol
               syntax: w     which means: word
             category: .:Base
             to input: type "C-x 8 RET 25cc" or "C-x 8 RET DOTTED CIRCLE"
          buffer code: #xE2 #x97 #x8C
            file code: #xE2 #x97 #x8C (encoded by coding system utf-8-unix)
              display: by this font (glyph code)
    xfthb:-PfEd-DejaVu Sans
Mono-normal-normal-normal-*-16-*-*-*-m-0-iso10646-1 (#xA23)

Character code properties: customize what to show
  name: DOTTED CIRCLE
  general-category: So (Symbol, Other)
  decomposition: (9676) ('◌')

b)

             position: 147 of 147 (99%), column: 1
            character: ึ (displayed as ึ) (codepoint 3638, #o7066, #xe36)
              charset: unicode (Unicode (ISO10646))
code point in charset: 0x0E36
               script: thai
               syntax: w     which means: word
             category: 2:upper diacritic, ^:Combining, t:Thai
             to input: type "C-x 8 RET e36" or "C-x 8 RET THAI
CHARACTER SARA UE"
          buffer code: #xE0 #xB8 #xB6
            file code: #xE0 #xB8 #xB6 (encoded by coding system utf-8-unix)
              display: by this font (glyph code)
    xfthb:-GOOG-Noto Sans Thai
UI-normal-normal-normal-*-16-*-*-*-*-0-iso10646-1 (#x77)

Character code properties: customize what to show
  name: THAI CHARACTER SARA UE
  old-name: THAI VOWEL SIGN SARA UE
  general-category: Mn (Mark, Nonspacing)
  decomposition: (3638) ('ึ')

I don't know much of anything about this, but wouldn't that suggest
that the bug is related to the font?

Best regards,
Stefan Kangas